/* Copyright (C) 1995 NetWin World, New Zealand, All rights reserved. */

/*
todo:
	Check for channel close everywhere, and exit or sleep as
	appropriate.
	Add keepalive timer so it will die if nothing happens for 30 minutes...

	This code is not nice, maybe because I didn't understand how 
	streaming would really work until after I wrote it... or maybe
	streaming both directions is just plain messey!

	Command parameters:
	Xmit sitename  -nostream -at *5
	Transmit file without streaming, every 5 minutes. 
*/

#ifdef VMS
#include <stat.h>
#else
#ifdef WIN32
#include <sys/types.h>
#endif
/*RHP no sys/ for mac thanks*/
#ifdef Mac
#include <stat.h>
#else
#include <sys/stat.h>
#endif
#endif

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#ifdef unix
#ifndef WIN32
#ifndef NOUNISTD
#include <unistd.h>
#endif
#endif
#endif
#include "dnews.h"
#include "conf.h"
#include "lib.h"
#include "str.h"
#include "emsg.h"
#include "nntp.h"
#include "xmit.h"
#include "ftslib.h"
#include "xmit_stub.h"
#ifndef TRUE
#define FALSE 0
#define TRUE (!FALSE)
#endif
void xmit_done(int delit);
static int keep_path = FALSE;
void svc_exiting(void);
void svc_exit(void);
void to_hello(char *bf, int sz);
void sendque_body(int cursend);
int group_match(char *wild, char *grp2);
void here_flush_status(char *bf, int sz);
void here_user_status(char *bf, int sz);
void here_pass_status(char *bf, int sz);
void xmit_done(int delit);
void send_ifready(void);
void sendque_doneone(int cur);
void send_upto(char *s);
void send_report(void);
void send_ifendtake(void);
void ring_clear(void);
void fts_background(void);
void send_mail(void);
void m_hello(char *s, int sz);
void m_helo_status(char *s, int sz);
void m_from_status(char *s, int sz);
void m_rcpt_status(char *s, int sz);
void m_data_status(char *s, int sz);
void m_body_status(char *s, int sz);
int m_mangle(String *str);
char *get_ahead(String *sitem, char *head);
void logit(char * arg_list, ...);
static int stripnws = FALSE;
static int stripto = FALSE;
void uucp_close(void);
int uucp_next(void);
int xmit_file_fts(void);


enum {S_EMPTY,S_READY,S_IHAVE,S_CHECK,S_SENDING,S_WANTED};
static char *state_str[]={"EMPTY", "READY", "IHAVE", "CHECK"
		, "SENDING", "WANTED" };
#define RINGSIZE 6 /* was 30 */ 

enum {	H_GROUP_STATUS,H_ITEM_STATUS,H_ITEM, H_HELLO, H_FLUSH_STATUS
	,T_IHAVE_STATUS,T_ITEM_STATUS, T_HELLO
	,T_STREAM_STATUS, T_CHECK_STATUS, T_TAKETHIS_STATUS
	,M_HELLO,M_HELO_STATUS,M_FROM_STATUS,M_RCPT_STATUS,M_DATA_STATUS
	,M_BODY_STATUS,H_USER_STATUS,H_PASS_STATUS};

#define MAXCHAN 20
static int chan_lasttime[MAXCHAN];
static int chan_state[MAXCHAN];
static int nsent,nread,nrejected,tstart;
void c_print(int chan,char * arg_list, ...);
void append_file(char *dst, char *src);
static int to_ready;
static int fromuser;
static int stream;
static int nsending,nchecks,nsendque;
char dnews_conf[BFSZ];
static char original_from[BFSZ];
void sendque_done(void);
void send_exit(void);
void send_takethis(int i);
void send_ifendcheck(void);
void send_die(void);
void chan_setstate(int c, int v);
void send_ihave(void);
void send_checks(void);
void to_stream_status(char *bf, int sz);
void to_takethis_status(char *bf, int sz);
void to_check_status(char *bf, int sz);
void getque_fill(void);
void send_exit(void);
void xmit_fts(String *anitem,char *bf);
char *strip_lf(char *s);

static char xgroups[2000];
char *next_group(void);


#define SENDSIZE (RINGSIZE/2)
char *get_que[RINGSIZE+5];

char *send_que[RINGSIZE+5];
int send_state[RINGSIZE+5];
String *send_str[RINGSIZE+5];

static int nget,cursend;
static int chere = -1;
static int cto = -1;
static int lclfail;
static int nostream;
void m_next_fail(void);

#ifndef BFSZ
#define BFSZ 500
#endif
static char at[BFSZ];
static char sitename[BFSZ];
static char filenames[BFSZ];
static char sendname[BFSZ];
static char requename[BFSZ];
static char uptoname[BFSZ];
static char header_to[BFSZ];
static char xlogname[BFSZ];
char *svc_getargs(char *s);
static int doat;
static int domail;
static char mailsvr[BFSZ];
static char mailaddress[BFSZ];
static char fromname[BFSZ];
static char uudir[BFSZ];
static char myeol[20];
static char allmatch[2000];
static int isuucp,isfts,noend,allgroups,isfeedfile;
static char u_user[BFSZ],u_pass[BFSZ];
static int asdots;
static int isdetach;
static int isdebug;
static int islogdata = FALSE;
void svc_init(char *sname);
#define dmsg logit
/*
#define DEBUGGING true 
*/

#ifdef WIN32
#ifdef DEBUGGING
int ServiceMain(int Xargc, char *Xargv[])
#else
int ServiceMain(int xargc, char *xargv[])
#endif
#else
#ifdef DEBUGGING
int main(int xargc, char *xargv[])
#else
int main(int argc, char *argv[])
#endif

#endif
{
	int i;
	FILE *f;
	char cmd[BFSZ];
	char *s;
#ifndef DEBUGGING 
#ifdef WIN32
	int argc;
	char *argv[20];

	log_open("xmit.log");

	emsg("xmit started %d\n",xargc);
	log_flush();	
	svc_init(xargv[0]);
	strcpy(cmd,svc_getargs(xargv[0]));
	emsg("Got args {%s} \n",cmd);
	log_flush();	
	if (strlen(cmd)==0) {
		for (argc=0; argc<xargc; argc++) {
			argv[argc] = xargv[argc];
		}
	} else {
		for (argc=0;TRUE;argc++) {
			s = get_word(cmd,argc); if (strlen(s)==0) break;
			argv[argc] = mystrdup(s,SD_XMIT);
		}
	}
#endif
#endif

#ifdef DEBUGGING
	int argc;
	char *argv[20];
	char cmd[BFSZ];
	strcpy(cmd,"xmit fts.site -fts -at * *");
	for (argc=0;TRUE;argc++) {
		s = get_word(cmd,argc); if (strlen(s)==0) break;
		argv[argc] = mystrdup(s);
	}
#endif

	f = fopen("xmit.debug","r");
	if (f!=NULL) {
		fgets(cmd,100,f); fclose(f);
		printf("Using DEBUG command line: %s\n",cmd);
		for (argc=0;TRUE;argc++) {
			s = get_word(cmd,argc); if (strlen(s)==0) break;
			argv[argc] = mystrdup(s,SD_XMIT);
		}
	}


	log_flush();	

	strcpy(myeol,"\012");
	for (i=1; i<argc; i++) {
		imsg("args [%d] %s \n",i,argv[i]);
		if (strcmp(argv[i],"-nostream")==0) nostream = TRUE;
		else if (strcmp(argv[i],"-mail")==0) {
			domail = TRUE;
			strcpy(mailaddress,argv[++i]);
		} else if (strcmp(argv[i],"-debug")==0) {
			isdebug = TRUE;
		} else if (strcmp(argv[i],"-logdata")==0) {
			islogdata = TRUE;
		} else if (strcmp(argv[i],"-name")==0) {
			strcpy(filenames,argv[++i]);
                } else if (strncmp(argv[i],"-con",4)==0) {
			strcpy(dnews_conf,argv[++i]);
		} else if (strcmp(argv[i],"-all")==0) {
			ncpy(allmatch,argv[++i],BFSZ-1);
			allgroups = TRUE;
		} else if (strcmp(argv[i],"-smtp")==0) {
			strcpy(mailsvr,argv[++i]);
		} else if (strcmp(argv[i],"-strip_newsgroups")==0) {
			stripnws = TRUE;
		} else if (strcmp(argv[i],"-strip_to")==0) {
			stripto = TRUE;
		} else if (strcmp(argv[i],"-keep_path")==0) {
			keep_path = TRUE;
		} else if (strcmp(argv[i],"-detach")==0) {
			isdetach = TRUE;
		} else if (strcmp(argv[i],"-uucp")==0) {
			strcpy(uudir,argv[++i]);
			isuucp = TRUE;
		} else if (strcmp(argv[i],"-user")==0) {
			strcpy(u_user,argv[++i]);
		} else if (strcmp(argv[i],"-pass")==0) {
			strcpy(u_pass,argv[++i]);
		} else if (strcmp(argv[i],"-to")==0) {
			strcpy(header_to,argv[++i]);
		} else if (strcmp(argv[i],"-fts")==0) {
			isfts = TRUE;
		} else if (strcmp(argv[i],"-word")==0) {
			fts_init("e:\\fts",FALSE);
			fts_test_word(argv[i+1]);
			return 0;
		} else if (strcmp(argv[i],"-lf")==0) {
			strcpy(myeol,"\012");
		} else if (strcmp(argv[i],"-bounce_user")==0) {
			fromuser = TRUE;
		} else if (strcmp(argv[i],"-dots")==0) {
			asdots = TRUE;
		} else if (strcmp(argv[i],"-crlf")==0) {
			strcpy(myeol,"\015\012");
		} else if (strcmp(argv[i],"-from")==0) {
			strcpy(fromname,argv[++i]);
		} else if (strcmp(argv[i],"-at")==0) {
			if (i+2>=argc) {
				emsg("Useage: -at \"mins\" \"hours\" \n");
				return 0;
			}
			doat = TRUE;
			strcpy(at,argv[++i]);
			strcat(at," ");
			strcat(at,argv[++i]);
		} else if (strcmp(argv[i],"-feed_file")==0) {
			isfeedfile = TRUE;
			isfts = TRUE;
		}
		else if (strlen(sitename)==0) strcpy(sitename,argv[i]);
		else {emsg("Unrecognized %s \n",argv[i]);}
	}
	if (strlen(sitename)==0) {
		emsg("Usage: xmit site.name -nostream -at mins hours -mail list@x.y.z -uucp c:/uucp  -lf\n");
		return 0;
	}
	if (isuucp) noend = TRUE;
	if (isfts) noend = TRUE;

	if (isdetach) lib_detach();
	imsg("step3 \n");
	if (strlen(filenames)==0) strcpy(filenames,sitename);
	strcpy(xlogname,feed_fname(filenames,".log"));
	log_open(xlogname); /*,feed_fname(filenames,".oldlog"));*/
	if (isfts) {
		fts_init(get_fts_dir(),FALSE);
	}
	strcpy(sendname,feed_fname(filenames,".send"));
	strcpy(requename,feed_fname(filenames,".reque"));
	strcpy(uptoname,feed_fname(filenames,".upto"));
	imsg("Sitename {%s} files {%s} send %s\n",sitename,filenames,sendname);

	xmit();
	return 1;
}
static FILE *ffeed,*freque;
int xmit(void)
{

	/* should open an _upto file and scan till that article */
	/* also open a _failed file and re-write failed articles with a count */

	int i;

	for (i=0; i<RINGSIZE+2; i++) get_que[i] = mymalloc(BFSZ);
	for (i=0; i<RINGSIZE+2; i++) send_que[i] = mymalloc(BFSZ);

	send_loop(); /* Doesn't return */
	return TRUE;
}
int reque_open(void)
{
	if (freque != NULL) {
	 	emsg("reque_open is already open \n");
		return TRUE;
	}
	freque = fopen(requename,"a");
	if (freque==NULL) {filemsg("Unable to open %s \n",requename); return FALSE;}
	return TRUE;
}
void reque_close(void)
{
	if (freque!=NULL) fclose(freque);
	freque = NULL;
}
int send_fopen(void)
{
	FILE *f;
	char *s;
	char bf[BFSZ],b2[BFSZ];
	int found = FALSE;

	if (ffeed!=NULL) emsg("Files are alrady open!!!\n");

	imsg("Opening %s \n",sendname);
	reque_open();
again:	ffeed = fopen(sendname,"r");	
	if (ffeed==NULL) {filemsg("Unable to open %s \n",sendname); return FALSE;}

	f = fopen(uptoname,"r");
	if (f==NULL) return TRUE;
	fgets(bf,BFSZ-10,f);
	fclose(f);
	s = strtok(bf," \t\n");
	if (s==NULL) {imsg("Nothing in upto file\n"); return TRUE;}
	/* strlwr(s); */
	if (strcmp(s,"NOMSGID")==0) {imsg("Nothing in upto file (nomsgid) \n"); return TRUE;}
	imsg("Restarting at %s \n",s);
	for (;(!feof(ffeed)) ;) { /* Read thru to the 'upto' flag */
		if (fgets(b2,BFSZ-1,ffeed)==NULL) break;
		if (strstr(b2,s)!=NULL) {found=TRUE; break;}
	}
	if (!found) {
		emsg("Could not find restart point %s, reprocessing entire file \n",s);
		fclose(ffeed);
		remove(uptoname);
		goto again;
	} else emsg("Found restart point\n");
	return TRUE;
}
void send_fclose(int delit)
{
	if (ffeed!=NULL) fclose(ffeed); ffeed = NULL;
	reque_close();
	if (delit) {
		imsg("Remove file %s \n",sendname);
		remove(sendname);
		remove(uptoname);
	}
}
int send_start(void)
{
	char bf[BFSZ];
	int max=0;
	tstart = lib_gmtime();
	nsent = nread = nrejected = 0;

	wmsg("Local site {%s} \n", config_get(C_MYNAME));
	chere = nntp_open(config_get(C_MYNAME));
	if (chere<0) return FALSE;
	ncpy(bf,sitename,BFSZ-1);
	if (!noend) {
		if (strlen(mailsvr)>0) strcpy(bf,mailsvr);
		if (domail) strcat(bf,":25");	
		wmsg("Destination  site {%s} \n", bf);
		cto = nntp_open(bf);
		to_ready = FALSE;
		if (cto<0) return FALSE;
		chan_setstate(cto,T_HELLO);
		if (domail) chan_setstate(cto,M_HELLO);
	}
	if (chere<0) return FALSE;
	chan_setstate(chere,H_HELLO); /* Wait for welcome messages */
	return TRUE;
}
int send_loop(void)
{
	sig_init(); /* Trap PIPE errors, rather than crash */

	if(isfeedfile) xmit_file_fts(); /* DOESN'T RETURN */
	nntp_startup();
	send_start();
	nntp_wait();   /* DOESN'T RETURN */
	return TRUE;
}
void send_show(void)
{
	int i;
	for (i=0; i<RINGSIZE; i++) {
		imsg("[%d] %s %s ",i,state_str[send_state[i]],send_que[i]);
	}
}
static int doexit;
void suck_setexit(void)
{
	doexit = TRUE;
	doat = FALSE;
}
static int dochecks;
void suck_do(void)	/* Background loop */
{
	static int last_flush;
	int delay = lib_gmtime() - last_flush;

	if (doexit) {
		emsg("Service closedown requested\n");
		xmit_done(FALSE);
	}
	fts_background();
	/* if first time, send mode commands to find out if we can stream 	*/
	/* and if we can send smart fetch commands 						  	*/
	/* Might need to do some startup article commands				  	*/
	dmsg("nget %d nsendque %d ncheck %d nsending %d \n",nget,nsendque,nchecks,nsending);

	if (delay>10) {log_flush(); last_flush = lib_gmtime();}

	if (!noend) if (!nntp_isopen(cto)) cto = -1;
	if (!nntp_isopen(chere)) chere = -1;
	if (noend) {
		if ((chere<0)) {
			emsg("Thats odd, channel closed from %d to %d \n",chere,cto);
			xmit_done(FALSE);
		}
	} else {
		if ((cto<0) || (chere<0)) {
			emsg("Thats odd, channel closed from %d to %d \n",chere,cto);
			xmit_done(FALSE);
		}
	}
	if (noend) to_ready = TRUE;
	if (to_ready) if ((nget==0) && (nsendque==0) && (nchecks==0) && (nsending==0)) {
		if (ffeed!=NULL) if (feof(ffeed)) {
			emsg("Closing because nget is empty and feof\n");
			xmit_done(TRUE);
		}
	}
	if (noend) to_ready = FALSE;
	send_ifready();
}
/* Called when finished sending */
#ifdef WIN32
void sleep(int x);
#endif
void xmit_done(int delit)
{
	static int last_time= -1;

	imsg("Done xmit\n");
	send_fclose(delit);
	if(!isfeedfile) {
		send_report();
		uucp_close();
		if (cto>=0) c_print(cto,"QUIT\015\012");
		if (chere>=0) c_print(chere,"QUIT\015\012");
		if (cto>=0) if (nntp_isopen(cto)) nntp_write_now(cto);
		if (chere>=0) if (nntp_isopen(chere)) nntp_write_now(chere);
		sleep(4); /* Give the channels a chance to close properly */
		if (cto>=0) if (nntp_isopen(cto)) nntp_close(cto); 
		if (chere>=0)  if (nntp_isopen(chere)) nntp_close(chere); 
		if (cto>=0) if (nntp_isopen(cto)) nntp_doclose(cto); 
		if (chere>=0) if (nntp_isopen(chere)) nntp_doclose(chere); 
		cto = -1; chere = -1;
	}

	if (doat) {
		if(!isfeedfile) dns_clear();
		imsg("Waiting for next xmit time {%s} \n",at);
		fts_background();

		log_flush();
		nget = nsendque = nchecks = nsending = 0;   /* Clear buffers, bit rough!!*/ 
		ring_clear();
again:
		sleep(5);
		for (;!conf_isat(at);) {
			fts_background();
			sleep(1);
			if (doexit) {
				emsg("Service closedown requested\n");
       				goto cleanup;
			}
		}
		if (doexit) {
			emsg("Service closedown requested\n");
			goto cleanup;
		}
		if ((lib_gmtime()-last_time)<70) {
			goto again;
		}
		last_time = lib_gmtime();
		
		if(!isfeedfile) send_start(); 
		log_flush();
		return;
	}
cleanup:
	send_exit();
}

/*
	Standard NNTP protocol, no extensions on either end.

	chere:
		>group ggg article xxx
		<status code (article follows)
		<status code
		<article
		<.
	cto:
		>ihave xxxx 
		<status code (send article)
		>send_data
		<status code 

chere:
	Ask for RINGSIZE items
	every time we finish with an item comletely, re-fill the ring
	
cto:
	


*/


int chan_read(int c, char *ss, int sz)
{
	int r=0;
	char *here="chere";
	chan_lasttime[c] = lib_gmtime();
	
	if (c==cto) here="cto"; 	
/*
	if (chan_state[c]!=H_ITEM) imsg("[%d:%s] %s ",c,here,ss);
	if (chan_state[c]!=H_ITEM) 
 	  imsg("Chan_read [%d:%s] %s \n",c,here,mode_str[chan_state[c]]); 
*/
	
	switch (chan_state[c]) {
	  case H_GROUP_STATUS:
		if (sz>2) here_group_status(ss,sz);
		break;
	  case H_ITEM_STATUS:
		if (sz>2) here_item_status(ss,sz);
		break;
	  case H_FLUSH_STATUS:
		if (sz>2) here_flush_status(ss,sz);
		break;
	  case H_USER_STATUS:
		if (sz>2) here_user_status(ss,sz);
		break;
	  case H_PASS_STATUS:
		if (sz>2) here_pass_status(ss,sz);
		break;
	  case H_ITEM:
		here_item(ss,sz);
		break;
	  case T_IHAVE_STATUS:
		if (sz>2) to_ihave_status(ss,sz);
		break;
	  case T_STREAM_STATUS:
		if (sz>2) to_stream_status(ss,sz);
		break;
	  case T_CHECK_STATUS:
		if (sz>2) to_check_status(ss,sz);
		break;
	  case T_TAKETHIS_STATUS:
		if (sz>2) to_takethis_status(ss,sz);
		break;
	  case T_ITEM_STATUS:
		if (sz>2) to_item_status(ss,sz);
		break;
	  case H_HELLO:
		if (sz>2) here_hello(ss,sz);
		break;
	  case T_HELLO:
		if (sz>2) to_hello(ss,sz);
		break;
	  case M_HELLO:
		if (sz>2) m_hello(ss,sz);
		break;
	  case M_HELO_STATUS:
		if (sz>2) m_helo_status(ss,sz);
		break;
	  case M_FROM_STATUS:
		if (sz>2) m_from_status(ss,sz);
		break;
	  case M_RCPT_STATUS:
		if (sz>2) m_rcpt_status(ss,sz);
		break;
	  case M_DATA_STATUS:
		if (sz>2) m_data_status(ss,sz);
		break;
	  case M_BODY_STATUS:
		if (sz>2) m_body_status(ss,sz);
		break;
	}
	return r;
}
static int nntp_err;
static char nntp_status[BFSZ];

void here_hello(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	if (nntp_err>299) {
		emsg("Bad welcome message %d, {%s} \n",nntp_err,nntp_status);
		xmit_done(FALSE);
		return;
	}
	if (strlen(u_user)>0) {
		imsg("Sending authinfo user %s\n",u_user);
		c_print(chere,"AUTHINFO USER %s\015\012",u_user);
		chan_setstate(chere,H_USER_STATUS);					
		return;
	}

	imsg("here_hello recieved, flushsite (%s)\n",filenames);
	chan_setstate(chere,H_FLUSH_STATUS);
	reque_close(); /* so dnews can copy it into the sending file */
	c_print(chere,"flushsite %s\015\012",filenames);
}
void here_user_status(char *bf, int sz)
{
	nntp_err = atoi(bf);	ncpy(nntp_status,bf,200);
	if (nntp_err>400) {emsg("authinfo user failed? {%s} \n",nntp_status); xmit_done(FALSE);}		
	chan_setstate(chere,H_PASS_STATUS);
	imsg("Sending authinfo pass ****\n");
	c_print(chere,"AUTHINFO PASS %s\015\012",u_pass);
}
void here_pass_status(char *bf, int sz)
{
	nntp_err = atoi(bf);	ncpy(nntp_status,bf,200);
	if (nntp_err>300) {emsg("authinfo pass failed? {%s} \n",nntp_status); xmit_done(FALSE);}		
	imsg("Logged in ok, now trying to flush feed %s\n",filenames);
	chan_setstate(chere,H_FLUSH_STATUS);
	reque_close(); /* so dnews can copy it into the sending file */
	c_print(chere,"flushsite %s\015\012",filenames);
}

void here_flush_status(char *bf, int sz)
{
	nntp_err = atoi(bf);	ncpy(nntp_status,bf,200);
	if (nntp_err!=280) {emsg("Flush failed? {%s} \n",nntp_status); xmit_done(FALSE);}
	imsg("Flush successful %s ",bf);
	chan_setstate(chere,H_ITEM_STATUS);
	if (!send_fopen()) {
		xmit_done(FALSE);
		return;
	}
	getque_fill();
}
char *strip_lf(char *s)
{
	static char bf[BFSZ];
	ncpy(bf,s,200);
	s = strchr(bf,'\r');	if (s!=NULL) *s = 0;
	s = strchr(bf,'\n');	if (s!=NULL) *s = 0;
	return bf;
}
void to_hello(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	imsg("to_hello recieved\n");
	imsg("helo <- %.80s\n",strip_lf(bf));
	if ((nntp_err!=200) && (nntp_err!=201)) {
		emsg("Bad welcome message %d, %s \n",nntp_err,nntp_status);
		xmit_done(FALSE);
	}
	chan_setstate(cto,T_STREAM_STATUS);
	c_print(cto,"MODE STREAM\015\012"); /* See if it can stream? */
}
void m_hello(char *s, int sz)
{
	imsg("welcome <- %.80s\n",strip_lf(s));
	if (strncmp(s,"220-",4)==0) return; /* wait for last status line */ 
	if (atoi(s)!=220) {
		emsg("Bad mail welcome message {%s} \n",s);
		xmit_done(FALSE);
	}
	c_print(cto,"HELO %s\015\012",config_get(C_MYNAME)); 
	chan_setstate(cto,M_HELO_STATUS);
}
void m_next(void)
{
	sendque_reque(cursend);
	sendque_doneone(cursend);
	nrejected++;
	chan_setstate(cto,M_FROM_STATUS);
	nsending = 0;
	send_mail();
}
void m_next_fail(void)
{
	sendque_doneone(cursend);
	nsending = 0;
	nrejected++;
	c_print(cto,"RSET\015\012");
	chan_setstate(cto,M_HELO_STATUS);
}
void m_helo_status(char *s, int sz)
{
	if (s[3]=='-') return; /* wait for last status line */ 
	imsg("helostatus <- %.80s\n",strip_lf(s));
	dmsg("to-stream-status %s ",s); 
	to_ready = TRUE;
	chan_setstate(cto,M_FROM_STATUS);
	if ((atoi(s)!=250)) {
		emsg("Helo Expecting 250, got %s",s);
		m_next();
	}
}
void m_from_status(char *s, int sz)
{
	char *ss;
	char bf[BFSZ];
	if (s[3]=='-') return; /* wait for last status line */ 
	imsg("from_status <- %.80s\n",strip_lf(s));
	if ((atoi(s)!=250)) {
		emsg("FROM: Expecting 250, got %s",s);
		m_next();
		return;
	}
	if (!m_mangle(send_str[cursend])) {
	 	m_next_fail();
		return;
	}
	if (allgroups) {
		ss = next_group();
		if (ss==NULL) {emsg("Can't find newsgroups info"); ss = "NULL";}		
		sprintf(bf,"%s%s",ss,mailaddress);
		imsg("Sending this to (%s)\n",bf);
		c_print(cto,"RCPT TO:<%s>\015\012",bf);
	} else {
		c_print(cto,"RCPT TO:<%s>\015\012",mailaddress);
	}
	chan_setstate(cto,M_RCPT_STATUS);
}
void m_rcpt_status(char *s, int sz)
{
	char bf[BFSZ];
	char *ss;
	if (s[3]=='-') return; /* wait for last status line */ 
	imsg("rcpt_status <- %.80s\n",strip_lf(s));
	if (allgroups) {
		if ((atoi(s)!=250)) {
			emsg("RCPT: Expecting 250, got %s",s);
		}			
		ss = next_group();
		if (ss==NULL) goto send_data;
		sprintf(bf,"%s%s",ss,mailaddress);
		imsg("Sending this to (%s)\n",bf);
		c_print(cto,"RCPT TO:<%s>\015\012",bf);
		chan_setstate(cto,M_RCPT_STATUS);
		return;
	} else {
		if ((atoi(s)!=250)) {
			emsg("RCPT: Expecting 250, got %s",s);
			m_next();
			return;
		}
	}

send_data:
	c_print(cto,"DATA\015\012");
	chan_setstate(cto,M_DATA_STATUS);
}
void wrap_long_lines(String *xitem)
{
	String *xresult;
	char *s,*line,*xend;
	char bf[10000];
	char *out;
	int inhead = TRUE;
	int tot,len;
	char saved;

	xresult = str_new();
	line = str_s(xitem);
	if (line==NULL) return;
	str_lock(xitem);
	for (;*line!=0; ) {
		xend = strchr(line,'\n');
		if (xend==NULL) break;
		xend++;
		saved = *xend;
		*xend = 0;
	/*	imsg("Found line %s\n",line);*/
		if (strlen(line)<3) inhead = FALSE;
		if (strlen(line)>200) {
			imsg("Wrapping long line %d\n",strlen(line));
			tot=0;
			out=bf;
			for (len=0,s = line; (*s!=0) && (tot<9000); s++) {
				if ( (len>200) || (   (len>80) && ((*s==' ')||(*s=='!')) ) ) {
					*out++ = '\r';		
					*out++ = '\n';	
					if (inhead) *out++ = '\t';		
					tot+=1;
					if (inhead) tot++;
					len = 0;
				}
				*out++ = *s;	
				tot++;
				len++;
			}
			if (out>bf) if (out[-1]!='\n') {
				imsg("Last char was %d\n",out[-1]);
				*out++ = '\r';
				*out++ = '\n';		
			}
			*out++ = 0;
			str_addsn(xresult,bf);
		} else str_addsn(xresult,line);
		line = xend;
		*xend = saved;
	}

	str_unlock(xitem);
	str_copy(xitem,xresult);

}
void m_data_status(char *s, int sz)
{
	if (s[3]=='-') return; /* wait for last status line */ 
	imsg("data_status <- %.80s\n",strip_lf(s));
	if ((atoi(s)!=354)) {
		emsg("DATA: Expecting 354, got %s",s);
		m_next();
		return;
	}
	send_state[cursend] = S_WANTED;

/*	str_write(send_str[cursend],"send1.txt");*/
	wrap_long_lines(send_str[cursend]);
/*	str_write(send_str[cursend],"send2.txt");*/
	sendque_body(cursend);
	chan_setstate(cto,M_BODY_STATUS);
}
char *fix_email(char *s)
{
        static char bf[BFSZ];
        static char bf2[BFSZ];
        char *orig=s;
        ncpy(bf,s,200);
        s = strtok(s,"<> \t\n");
        for (;s!=NULL;) {
                if (strchr(s,'@')!=NULL) {
                        sprintf(bf2,"<%s>",s);
                        return bf2;
                }
                s = strtok(NULL,"<> \t\n");
        }
        return orig;
}

/* change From: header, and junk it if contains header X-Gated-To  */
#define matches(a,b) (strncmp(a,b,strlen(b))==0)
#define EOL "\015\012"

#define addline(xx) {strcpy(xout,xx); strcat(xout,EOL); xout += strlen(xx)+2;}
int m_mangle(String *str)
{
	char *s,*s2;
	char *out;
	char *xout;
	char bf[400];
	int r = TRUE;
	int donehead = FALSE;
	int gotreply = FALSE;
	char from[BFSZ];

	if (str==NULL) {emsg("Bug in mangle, please let us know\n"); return FALSE;}
	strcpy(from,"");
	out = mymalloc(str_len(str)+1000);
	xout = out;
	s = str_s(str);
/*	dmsg("String %s",s); */
	s2 = strstr(s,EOL);

	if (strlen(header_to)>0) {
		sprintf(bf,"To: %s",header_to);
	} else {
		if (allgroups) {
			sprintf(bf,"To: news_group%s",mailaddress);
		} else {
			sprintf(bf,"To: %s",mailaddress);
		}
	}
	if (!stripto) addline(bf);
	if (strlen(fromname)>0) {
		sprintf(bf,"From: %s",fromname);
		addline(bf);
	}
	for (;s2!=NULL;) {
		*s2 = 0;
		/* dmsg("Sss = %s\n",s); */
		if (!donehead) if (strlen(s)==0) {
			sprintf(bf,"X-Gateway-From: %s",fromname);
			addline(bf);
			donehead = TRUE;
			if (!gotreply) {
			/*	x = strchr(from,':');
				if (x!=NULL) {
					sprintf(bf,"Reply-To%s",x);
					addline(bf);
				}		 	 */
			}
		}
		if (!donehead) {
			/*if (matches(s,"From:")) {strcpy(from,s); goto cont;}*/
			if (strlen(fromname)>0) {
				if (matches(s,"From:")) {
					strcpy(from,s); 
					ncpy(original_from,fix_email(s+6),200);
					sprintf(bf,"X-Originally-%s",from);
					addline(bf);
					goto skip_line;
				}
				if (strncmpnc(s,"Reply-To:",9)==0) {
					strcpy(from,s); 
					ncpy(original_from,fix_email(s+6),200);
					sprintf(bf,"X-Originally-%s",from);
					addline(bf);
					goto skip_line;
				}
			}
			if (matches(s,"Subject:")) imsg("%.90s\n",s);
			if (matches(s,"Message-ID:")) imsg("%.90s\n",s);
			if (stripnws) if (matches(s,"Newsgroups:")) goto skip_line;
			if (matches(s,"NNTP-Posting-Host:")) goto skip_line;
			if (!keep_path) if (matches(s,"Path:")) goto skip_line;
			if (matches(s,"Xref:")) goto skip_line;
			if (matches(s,"Reply-To:")) gotreply = TRUE;
			if (matches(s,"X-Gateway-From:")) {emsg("Already gone thru gateway\n"); r = FALSE; goto ret;}
			if (matches(s,"Message-ID: <fake@netwin")) {emsg("Looks like the dnews downloading message, skipping it\n"); r = FALSE; goto ret;}
			if (matches(s,"To:")) {goto skip_line;}
		}
		addline(s);
skip_line:;
		s = s2 + strlen(EOL);
		s2 = strstr(s,EOL);
	}
	str_copysn(str,out);
		
ret:
	myfree(out);
	return r;
}
void m_body_status(char *s, int sz)
{
	imsg("body_status <- %.80s\n",strip_lf(s));
	if ((atoi(s)!=250)) {
		emsg("DATA body: Expecting 250, got %s",s);
		m_next();
		return;
	}
	nsent++;
	chan_setstate(cto,M_FROM_STATUS);
	sendque_doneone(cursend);
	nsending = 1;
	send_ifendtake();
	getque_fill();
}
void here_group_status(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	if (nntp_err!=211) {
		emsg("Can't read local message group status {%s} \n",nntp_status);
		if (nntp_err!=423) lclfail++;
		chan_setstate(chere,H_ITEM_STATUS);
		return;
	}
	chan_setstate(chere,H_ITEM_STATUS);
}
void here_item_status(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	if (nntp_err!=220) {
		imsg("ERROR: Can't read local message item status {%s} \n",nntp_status);
		if (nntp_err!=423) lclfail++;
		getque_next(); /* Ask for the next one */
		chan_setstate(chere,H_ITEM_STATUS);
		return;
	}
	chan_setstate(chere,H_ITEM);
}
void here_item(char *bf, int sz)
{
	static String *anitem;
	if (anitem==NULL) anitem = str_new();

	if (strcmp(bf,".\015\012")==0) {
		/*str_write(anitem,"here.txt");*/
		chan_setstate(chere,H_ITEM_STATUS);
		if (isfts) xmit_fts(anitem,get_que[0]);
		else if (isuucp) uucp_send(anitem);
		else sendque_add(anitem);
		str_clear(anitem);
		getque_next(); /* Ask for the next one */
	} else {
		str_adds(anitem,bf,sz);
	}
}
void xmit_fts(String *anitem,char *bf)
{
 	fts_add(getque_group(bf),atoi(getque_num(bf)),str_s(anitem));

	if (nread % 50 == 0) send_upto(getque_mid(bf));
}

void to_ihave_status(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	if (nntp_err!=335) {
		if ((nntp_err==436) || (nntp_err==480)) {
			if (nntp_err==480) imsg("Transfer permission denied on your upstream site\n");
			sendque_reque(cursend);
			imsg("IHAVE retry: %s",nntp_status); 
		} else { 
			imsg("Rejected ihave status %s\n",nntp_status);
		}
		nrejected++;
		sendque_done();
		chan_setstate(cto,T_IHAVE_STATUS);
		return;
	}
	send_state[cursend] = S_WANTED;
	sendque_body(cursend);
	chan_setstate(cto,T_ITEM_STATUS);
}
void to_item_status(char *bf, int sz)
{
	nntp_err = atoi(bf);
	ncpy(nntp_status,bf,200);
	if (nntp_err!=235) {
		if (nntp_err==436) {
			imsg("item retry: %s",nntp_status); 
			sendque_reque(cursend);
		} else { 
			imsg("Rejected item status %s\n",nntp_status);
		}
		nrejected++;
		sendque_done();
		chan_setstate(cto,T_IHAVE_STATUS);
		return;
	}
	nsent++;
	sendque_done();
	chan_setstate(cto,T_IHAVE_STATUS);
}
void sendque_done(void)
{
	if (noend) return;
	sendque_doneone(cursend);
	nsending--;
	send_ifready();
}


/*msgid group:num f:retry */
/*
chan_write_s(chan,"480 transfer permission denied\015\012");
chan_write_s(chan,"436 sorry disk full - try again later\015\012");
chan_write_s(chan,"435 article not wanted - do not send it\015\012");
chan_write_s(chan,"335 send article to be transferred.  End with <CR-LF>.<CR-LF>\015\012");

I'd like to stream, 
*/

void getque_add(char *bf)
{
	if (strlen(bf)>2) {
		if (isfts) {
			c_print(chere,"XDARTICLE %s:%s 0-10000\015\012",getque_group(bf),getque_num(bf));
		} else {
			c_print(chere,"ARTICLE %s:%s\015\012",getque_group(bf),getque_num(bf));
		} 
		ncpy(get_que[nget++],bf,BFSZ-1);
	}
}
void getque_next(void)
{
	int i;
	if (nget>0) {
		for (i=0; i<(nget-1); i++) {
			strcpy(get_que[i],get_que[i+1]);
		}
		nget--;
	}

	getque_fill();
}
int send_empty(void)
{
	int i;
	for (i=0; i<RINGSIZE; i++) {
		if (send_state[i]==S_EMPTY) return i;
	}
	emsg("PANIC, NO EMPTY BUFFERS, SOMETHING IS WRONG \n");
	send_show();
	return 0;
}
void ring_clear(void)
{
	int i;
	for (i=0; i<RINGSIZE; i++) {
		send_state[i] = S_EMPTY;
	}
}
int next_ready(void)
{
	int i;
	for (i=0; i<RINGSIZE; i++) {
		if (send_state[i]==S_READY) return i;
	}
	emsg("No more messages to send\n");
	return -1;
}
void sendque_add(String *item)
{
	int cur = send_empty();

	nsendque++;
	/* imsg("Adding send[%d] %s \n",cur,get_que[0]); */
	/* imsg("Message %s \n",str_s(item)); */

	if (send_str[cur]==NULL) send_str[cur] = str_new();
	str_clear(send_str[cur]);
	str_copy(send_str[cur],item);
	ncpy(send_que[cur],get_que[0],BFSZ-1);
	send_state[cur] = S_READY;
	send_ifready();
}
void send_ifready(void)
{
	getque_fill();
	dmsg("Send ifread, nget %d nsendque %d nsending %d nchecks %d \n",nget,nsendque,nsending,nchecks);
	if (!to_ready) {dmsg("Waiting for stream status still...\n"); return;}
	if (nsending>0) {dmsg("Waiting for sending to be empty ...\n"); return;}
	if (nchecks>0) {dmsg("Waiting for nchecks to be empty ...\n"); return;}
	if (nsendque<SENDSIZE ) dmsg("Waiting for nsendque to grow ...\n"); 
 
	if (stream) {
		if (nsendque>=SENDSIZE ) send_checks();
		else if ((nsendque>0) && (nget==0)) send_checks();
	} else {
		if (nsendque>0) send_checks();
	}
}
void sendque_body(int cursend)
{
	/* imsg("Send Message %s \n",str_s(send_str[cursend])); */
	FILE *f;

	nntp_write(cto,send_str[cursend]);
	c_print(cto,".\015\012");

	if (islogdata) {		
		f = fopen(feed_fname(filenames,".data"),"a");
		if (f!=NULL) {
		 fprintf(f,"-------------Body sent follows------------------\n");
		 fwrite(str_s(send_str[cursend]),1,str_len(send_str[cursend]),f);
		 fprintf(f,".\n");
		 fprintf(f,"-------------End of message sent ------------------\n");
		 fclose(f);
		}
	}
	
	if (send_state[cursend] != S_WANTED) emsg("fatal, state wrong %d \n",send_state[cursend]);
	send_state[cursend] = S_SENDING;
}
void send_ihave(void)
{
	cursend = next_ready(); if (cursend<0) return;
	c_print(cto,"IHAVE %s\015\012",getque_mid(send_que[cursend]));
	send_state[cursend] = S_IHAVE;
	nsending++;
}
char *next_groupx(void);
char *next_group(void)
{
	char *ss;
	char *next;
	
again:	next = next_groupx();
	if (next==NULL) return NULL;
	if (group_match(allmatch,next)) {
		if (!asdots) {for (ss=next;*ss!=0;ss++) if (*ss=='.') *ss = '_';}
		return next;
	} else imsg("Not sending group name (%s)\n",next);
	goto again;	
}
char *next_groupx(void)
{
	char rest[2000];
	static char next[2000];
	char *s;
	if (strlen(xgroups)==0) return NULL;
	s = strchr(xgroups,',');
	if (s==NULL) {
		ncpy(next,xgroups,BFSZ);
		strcpy(xgroups,"");
	} else {
		*s = 0;
		ncpy(next,xgroups,BFSZ);
		strcpy(rest,s+1); strcpy(xgroups,rest);
	}
	s = strtok(next," \r\n\t");
	return s;
}
void send_mail(void)
{
	
	cursend = next_ready(); if (cursend<0) return;
	if (fromuser) {
		if (strlen(original_from)==0) strcpy(original_from,"from_header_not_found");
		imsg("Using bounce address (%s)\n",original_from);
		c_print(cto,"MAIL FROM:%s\015\012",original_from);
	} else {
		c_print(cto,"MAIL FROM:<gateway@%s>\015\012",config_get(C_MYNAME));
	}
	if (allgroups){
		ncpy(xgroups,get_ahead(send_str[cursend],"Newsgroups:"),1000);
	} else {
	}
	send_state[cursend] = S_IHAVE;
	nsending++;
}
void sendque_reque(int cur)
{
	imsg("Reque %d {%s} \n",cur,send_que[cur]);
	if (freque==NULL) if (!reque_open()) return;
	fprintf(freque,"%s",send_que[cur]);
}


/*-------------- Streaming specific code ---------------------------------*/
void send_checks(void)
{
	int i;
	if (!to_ready) dmsg("send_checks called, but not ready yet\n"); 
	if (!to_ready) {dochecks = TRUE; return;}
	if (domail) {send_mail(); return;}
	if (!stream) {send_ihave(); return;}
	nchecks = 0;
	for (i=0; i<RINGSIZE && (nchecks<(RINGSIZE/2)); i++) {
	  if (send_state[i] == S_READY) {
		c_print(cto,"CHECK %s\015\012",getque_mid(send_que[i]));
		send_state[i] = S_CHECK;
		nchecks++;
	  }
	}
	chan_setstate(cto,T_CHECK_STATUS);
}
void to_stream_status(char *bf, int sz)
{
	nntp_err = atoi(bf);
	dmsg("to-stream-status %s ",bf); 
	to_ready = TRUE;
	if ((nntp_err!=203) || nostream) {
		if (!nostream) {
			wmsg("Oh dear, he doesn't know how to stream\n");
		} else wmsg("Using non streaming xfer protocl\n");
		chan_setstate(cto,T_IHAVE_STATUS);
		return;
	}
	stream = TRUE;
	chan_setstate(cto,T_CHECK_STATUS);
}
void to_takethis_status(char *bf, int sz)
{
	int cur = mid_find(bf);
	ncpy(nntp_status,bf,200);
	dmsg("Takethis-status[%d] %s",cur,bf);

	nntp_err = atoi(bf);


	if ((nntp_err==239) && (cur>=0)) {
		nsent++;
	} else if ((nntp_err==400) || (cur<0)) { /* Connection closed (e.g. disk full)  */
		xmit_done(FALSE);
		return;
	} else if ((nntp_err==431) ) { 
		sendque_reque(cur);
		nrejected++;
	} else if (nntp_err==439) {
		imsg("Rejected item status %s",nntp_status);
		nrejected++;
	} else {
		emsg("Unexpected Rejection %s\n",nntp_status);
		nrejected++;
	}
	sendque_doneone(cur);
	send_ifendtake();
	getque_fill();
}
void sendque_doneone(int cur)
{
	if (nread % 50 == 0) send_upto(getque_mid(send_que[cur]));
	if (send_state[cur] != S_SENDING) 
	  if (send_state[cur] != S_CHECK) 
	    if (send_state[cur] != S_WANTED) emsg("fatal, DONE state wrong %d \n",send_state[cur]);
	send_state[cur] = S_EMPTY;
	strcpy(send_que[cur],"");

	nsendque--;
	getque_fill();
}
void to_check_status(char *bf, int sz)
{
	int cur;

	ncpy(nntp_status,bf,200);
	nntp_err = atoi(bf);
	cur = mid_find(bf);
	dmsg("Check-status[%d] %s",cur,bf);
	if (cur<0) {
		emsg("Got message id that I couldn't find?? %s\n",nntp_status); 
		xmit_done(FALSE);
	}
	if (nntp_err==238) {
	  	if (send_state[cur] != S_CHECK) emsg("fatal, DONE state wrong %d \n",send_state[cur]);
		send_state[cur] = S_WANTED;
		send_takethis(cur);
		send_ifendcheck();
		return;
	}
	if (nntp_err==400) { /* Connection closed (e.g. disk full)  */
		xmit_done(FALSE);
		return;
	}
	if ((nntp_err==431)) { 
		imsg("check retry: %s",nntp_status); 
		nrejected++;
		sendque_reque(cur);
		sendque_doneone(cur);
		send_ifendcheck();
		return;
	}
	sendque_doneone(cur);
	send_ifendcheck();
	imsg("Rejected check status %s",nntp_status);
	nrejected++;
	return;
}
void send_upto(char *s)
{
	FILE *f;
	f = fopen(uptoname,"w");
	if (f==NULL) {filemsg("Can't open %s \n",uptoname); return;}
	fprintf(f,"%s\n",s);
	fclose(f);
}
void send_takethis(int i)
{
	c_print(cto,"TAKETHIS %s\015\012",getque_mid(send_que[i]));
	sendque_body(i);
	nsending++;
}
void send_ifendcheck(void)
{
	nchecks--;
	if (nchecks==0) {
		chan_setstate(cto,T_TAKETHIS_STATUS);
	}
}
void send_ifendtake(void)
{
	nsending--;
	if (nsending<=0) {
		nsending = 0;
		send_checks();
	}
}

void getque_fill(void)
{
	char b2[BFSZ];
	if (ffeed==NULL) return;
	for (;(!feof(ffeed)) && ((nget+nsendque)<(RINGSIZE-1)) ;) {
		if (fgets(b2,BFSZ-1,ffeed)==NULL) break;
		nread++;
		if ((nread % 50) == 0) send_report();
		getque_add(b2);
	}
	dmsg("getque fill, nget %d \n",nget);
}


/*-- Util routines --------------------------------------------------------*/
int mid_find(char *s)
{
	char bf[BFSZ];	
	int i;
	char *x;
	char *ss=s;
	ncpy(bf,s,BFSZ-1);
	s = strtok(bf," \t\015\012");
	s = strtok(NULL," \t\015\012");
	if (s==NULL) {
		emsg("DUD message id returned %s\n",ss);
		return -1;
	}
	x = strchr(s,'>');
	if (x!=NULL) *(x+1) = 0;
	for (i=0; i<RINGSIZE; i++) {
		if (strcmp(s,getque_mid(send_que[i]))==0) {
			return i;
		}
	}
	emsg("DUD message id returned {%s}\n",ss);
	return -1;
}
void append_file(char *dst, char *src)
{
	FILE *fsrc,*fdst;
	char bf[BFSZ];

	fsrc = fopen(src,"r");
	if (fsrc==NULL) return;
	fdst = fopen(dst,"a");
	if (fdst==NULL) { filemsg("Can't open output file\n"); return;}
		
	for (;!feof(fsrc) ;) {
		if (fgets(bf,BFSZ-10,fsrc)==NULL) break;
		fprintf(fdst,"%s",bf);
	}
	fclose(fdst); fclose(fsrc);
}
void chan_setstate(int c, int v)
{
	/* if (c==cto) here="cto"; 	
	imsg("[%s] Set State %s ",here,mode_str[v]);*/
	chan_state[c] = v;
}
char *getque_mid(char *s)
{
	static char bf[BFSZ];
	if (strlen(s)==0) return "NOMSGID";
	ncpy(bf,s,BFSZ-1);
	s = strtok(bf," \t");
	if (s==NULL) {emsg("No message id ? \n"); return "NOMSGID";}
	return s;
}
char *getque_group(char *s)
{
	static char bf[BFSZ];
	ncpy(bf,s,BFSZ-1);
	s = strtok(bf," \t\n");
	if (s!=NULL) s = strtok(NULL,": \t\n");
	if (s==NULL) {emsg("No group ? \n"); return "NOMSGID";}
	return s;
}
char *getque_num(char *s)
{
	static char bf[BFSZ];
	ncpy(bf,s,BFSZ-1);
	s = strtok(bf," \t\n");
	if (s!=NULL) s = strtok(NULL,": \t\n");
	if (s!=NULL) s = strtok(NULL,": \t\n");
	if (s==NULL) {emsg("No number id ? \n"); return "NOMSGID";}
	return s;
}
void send_report(void)
{
	double g;
	int delay = lib_gmtime() - tstart;
	if (delay<1) delay = 1; 
	g = ((double) nsent)/(delay);
	if (isfts) {
		g = ((double) nread)/(delay);
		imsg("%d processed,  %g per second \n",nread,g);
	} else {
		imsg("%d read, %d sent, %d rejected, %g per second \n",nread,nsent,nrejected,g);
	}
	dmsg("nget %d nsendque %d ncheck %d nsending %d, ready %d \n",nget,nsendque,nchecks,nsending,to_ready);
	log_flush();
}
void dnews_exit(char *reason, char *file, int line)
{
	imsg("DNEWS_EXIT %s\n",reason);
	send_exit();
}
char *main_msg(void)
{
	return "XMIT successfully running!";
}		
void send_exit(void)
{
	send_report();
	imsg("Exiting\n");
	log_flush();
#ifdef WIN32
	imsg("SVC Exiting\n");
        svc_exiting();
	imsg("SVC Exit\n");
	svc_exit();
#endif
	imsg("Exit completed\n");
	exit(1);
}
void send_die(void)
{
	emsg("Xmit dieing\n");
	log_flush();
	exit(1);
}
void c_print(int chan,char * arg_list, ...)
{
 	va_list arg_ptr;
 	char *format, output[1000];
 	va_start(arg_ptr, arg_list);
 	format = arg_list;
	vsprintf(output, format, arg_ptr);
	nntp_write_s(chan,output,strlen(output));
	dmsg("nntpcmd [%d] %s ",chan,output); 
	if (strstr(output,"AUTHINFO")==NULL) if (domail) imsg("write [%d] %.200s",chan,output); 

}
char *one_line(char *s)
{
	static char *next;
	char *ss;
	
	if (s==NULL) s = next;
	ss=s;
 	s = strchr(s,'\012');
	if (s==NULL) return NULL;
	*s = 0;
	next = s+1;
	if (s>ss) if (*(s-1)=='\015') *(s-1) = 0;
	return ss;
}
void uucp_send(String *item)
{
	char *bf;
	char *out;
	char *s;
	int len=0;

	bf = mymalloc(str_len(item)+100);
	out = bf;
 	s = str_s(item);
	s = one_line(s);
	for (;s!=NULL;) {
		if (strcmp(s,"..")==0) strcpy(s,".");
		sprintf(out,"%s%s",s,myeol);
		out += strlen(out);
		len += strlen(s) + 1;
		s = one_line(NULL);
	}
	uucp_write(bf,len);
	myfree(bf);
}
#define UUCP_SIZE 2000000
static FILE *fout;
static int uucp_size;
static char uucp_curname[BFSZ];
static char uucp_newname[BFSZ];
void uucp_write(char *bf, int len)
{
	int n;
	char *fname = uucp_curname;
	if (uucp_size>UUCP_SIZE) uucp_close();
 	if (fout==NULL) {
		n = uucp_next();
	 	sprintf(uucp_curname,"%s/NEWS%04d.NEW",uudir,n);
	 	sprintf(uucp_newname,"%s/NEWS%04d.BAG",uudir,n);
		fout = fopen(fname,"wb");
		if (fout==NULL) {
			filemsg("Can't open %s \n",fname);
			send_exit();
		}
	}
	fprintf(fout,"#! rnews %d%s",len,myeol);
	fwrite(bf,1,strlen(bf),fout);
	uucp_size += len;
}
void uucp_close(void)
{
 	if (!isuucp) return;
	if (fout!=NULL) fclose(fout);
	rename(uucp_curname,uucp_newname);
	fout = NULL;
	uucp_size = 0;
}
int uucp_next(void)
{
	char fname[BFSZ];
	char bf[BFSZ];
	int lcount=0;
 	FILE *f;

 	sprintf(fname,"%s/count.dat",uudir);
        f = fopen(fname,"r");
        if (f!=NULL) {
                fgets(bf,199,f);
                lcount = atoi(bf);
                fclose(f);
        }
        remove(fname);
        f = fopen(fname,"w");
        if (f!=NULL) {
                fprintf(f,"%d\n",lcount+1);
                fclose(f);
        }
 	return lcount;
}
int post_local(String *xitem, char *addr, int ismod)
{
        return TRUE;
}
char *get_head(char *s);
char *get_ahead(String *sitem, char *head)
{
        char tmp[50],tmp2[BFSZ];
        char *s = str_s(sitem);

        if (strchr(head,':')==NULL) {
                ncpy(tmp2,head,BFSZ-2); head = tmp2;
                strcat(head,":");
        }
        s = str_s(sitem);
        if (s!=NULL) for (;s!=NULL && *s!=0;) {
                strncpy(tmp,s,40); tmp[40] = 0; 
                if (strncmp(s,EOL,strlen(EOL))==0) break;
                if (strncmpnc(s,head,strlen(head))==0) {
                        return get_head(s);
                }
		for (s=s+1;*s!=0;s++) if (*s=='\n') break;
		if (*s==0) break;
		s += 1;
        }
        return "";
}
char *get_head(char *s)
{
        static char tmp[11000];    /* No header should excced this !!! */
        char *o = tmp;
        s = strchr(s,':');
        if (s==NULL) return "FSRV-ERROR";
        s++;
        if (*s==0) return "";
        for (;(*s==' ' || *s=='\t') && (*s!=0);s++) ;  /*Skip over leading spaces*/
        for (; ((o-tmp)<10000) && (*s!=0);) {
                if (*s=='\015') {
                        if ( s[2]==' ' || s[2]=='\t' ) {
                                s+=3;  /* Eat eol and leading spaces */
                                for (;*s!=0 && isspace(*s) ;) s++ ;
                        } else break; 
                }
                if (*s==0) break;
                if (*s=='\t') {*o++ = ' '; s++;}  /* Convert tabs to spaces */
                else *o++ = *s++; 
        }       
        *o++ = 0;
        return tmp;
}

int group_match(char *wild, char *grp2)
{
        char bf[1000];
        char grp[BFSZ];
        int m=TRUE,lastm;
        char *s,*p,*w;
	int done,len;
	int all;
	int lastall;

	lastall = FALSE;
        ncpy(grp,grp2,BFSZ-1); strlwr(grp);
        lastm = FALSE;
	p = wild;
	done = FALSE;
	for (;!done;) {
 		s = strchr(p,',');
		if (s==NULL) {s = wild + strlen(wild); done = TRUE;}
		if (*p==0) break;
		len = s - p;
		if (len>100) len = 100;
		strncpy(bf,p,len); bf[len] = 0;
		strlwr(bf); w = bf;

                m = TRUE;
		all = FALSE;
                if (*w=='!') {
                        w++;
                        m = FALSE;
                }
                if (*w=='@') {
                        w++;
                        m = FALSE;
			all = TRUE;
                }
                if (match_wild(w,grp)) { lastm = m; lastall = all;} 

		p = s + 1;
	}
	return lastm;
}
#ifdef TRUE
#undef TRUE
#endif
#ifdef FALSE
#undef FALSE
#endif

#define TRUE			1
#define FALSE			0
#define ABORT			-1
#define NEGATE_CLASS		'^'

int domatch(char *text, char *p)
{
    register int	last;
    register int	matched;
    register int	reverse;

    for ( ; *p; text++, p++) {
	if (*text == '\0' && *p != '*')
	    return ABORT;
	switch (*p) {
	case '\\':
	    /* Literal match with following character. */
	    p++;
	    /* FALLTHROUGH */
	default:
	    if (*text != *p)
		return FALSE;
	    continue;
	case '?':
	    /* Match anything. */
	    continue;
	case '*':
	    while (*++p == '*')
		/* Consecutive stars act just like one. */
		continue;
	    if (*p == '\0')
		/* Trailing star matches everything. */
		return TRUE;
	    while (*text)
		if ((matched = domatch(text++, p)) != FALSE)
		    return matched;
	    return ABORT;
	case '[':
	    reverse = p[1] == NEGATE_CLASS ? TRUE : FALSE;
	    if (reverse)
		/* Inverted character class. */
		p++;
	    matched = FALSE;
	    if (p[1] == ']' || p[1] == '-')
		if (*++p == *text)
		    matched = TRUE;
	    for (last = *p; *++p && *p != ']'; last = *p)
		if (*p == '-' && p[1] != ']'
		    ? *text <= *++p && *text >= last : *text == *p)
		    matched = TRUE;
	    if (matched == reverse)
		return FALSE;
	    continue;
	}
    }
    return *text == '\0';
}


int match_wild(char *p,char *text)
{
    if (p[0] == '*' && p[1] == '\0')
	return TRUE;
    return domatch(text, p) == TRUE;
}
void emsg_do(int lvl, char *s); 
void fimsg(char * arg_list, ...)
{
        va_list arg_ptr;
        char *format;
        int len;
        char bf[BFSZ];
	char output[5000];

        ncpy(bf,strerror(errno),BFSZ-1);

        va_start(arg_ptr, arg_list);
        format = arg_list;
        len = vsprintf(output, format, arg_ptr);
        if (len>=5000) emsg_do(D_ERROR,"FATAL, fiMSG ERROR TOO LONG\n");
        imsg("(%s) %s",bf,output);
}
void logit(char * arg_list, ...)
{
 	va_list arg_ptr;
 	char *format, output[8000];

	if (!isdebug) return;
 	va_start(arg_ptr, arg_list);
 	format = arg_list;

	vsprintf(output, format, arg_ptr);
	imsg("%s",output);
}

#ifndef _PATH_DEVNULL
#define _PATH_DEVNULL "/dev/null"
#endif
int lib_detach(void) 
{
#ifndef VMS
#ifndef WIN32
        int fd;
	int noclose=0;

        switch (fork()) {
        case -1:
		printf("Detach(), fork failed %s\n",strerror(errno));
                return (-1);
        case 0:
                break;
        default:
                _exit(0);
        }

        if (setsid() == -1) {
		printf("Detach(), child setsid failed %s\n",strerror(errno));
                return (-1);
	}

        if (!noclose && (fd = open(_PATH_DEVNULL, O_RDWR, 0)) != -1) {
                (void)dup2(fd, STDIN_FILENO);
                (void)dup2(fd, STDOUT_FILENO);
                (void)dup2(fd, STDERR_FILENO);
                if (fd > 2)
                        (void)close (fd);
        }
#endif
#endif
        return (0);
}

char *getSpoolDir(int spool)
{
	static char s[BFSZ];
	int dx;

	if(spool==1) {
		ncpy(s,config_get(C_SPOOL),BFSZ-1);
	} else if(spool<10) {
		dx=C_SPOOL2+spool-2;
		ncpy(s,config_get(C_SPOOL2+dx),BFSZ-1);
	} else if (spool<30) {
		dx=C_SPOOL10+spool-10;
		ncpy(s,config_get(C_SPOOL10+dx),BFSZ-1);
	} else ncpy(s,"",2);
	return s;
}

int fget_next_info(FILE *f, char *mid, char *grp, int *n,int *bkt, int *offset, int *len, int *pile, int *spool,int *eof)
{
	char xbf[BFSZ];
	char *s;

	*eof=FALSE;
	*mid='\0';
skipline:
	if (feof(f)) {
		*eof=TRUE;
		return FALSE;
	}
	if (fgets(xbf,200,f)==NULL) {
		*eof=TRUE;
		return FALSE;
	}
	/*mid*/ s = strtok(xbf," "); if (s==NULL) return FALSE;
	ncpy(mid,s,100);
	if (strlen(s)>100) return FALSE;
	/*grp*/ s = strtok(NULL,":"); if (s==NULL) return FALSE;
	ncpy(grp,s,BFSZ-1);
	/*n  */ s = strtok(NULL,":"); if (s==NULL) return FALSE;
	*n = atoi(s);
	/*bkt*/ s = strtok(NULL,":"); if (s==NULL) return FALSE;
	*bkt = atoi(s);
	/*offset*/ s = strtok(NULL,":"); if (s==NULL) return FALSE;
	*offset = atoi(s);
	/*len*/ s = strtok(NULL,":"); if (s==NULL) goto skipline;
	*len = atoi(s);
	/*spool*/ s = strtok(NULL,":"); if (s==NULL) goto skipline;
	*spool = atoi(s); 
	if (*spool < 0) return FALSE;
	if (*spool > 30) return FALSE;
	/*pile*/ s = strtok(NULL,": "); if (s==NULL) goto skipline;
	*pile = atoi(s);
	/* ntries */ s = strtok(NULL," "); 
	return TRUE;
}

int xmit_file_fts()
{
	char lbuff[BFSZ],mid[BFSZ],grp[BFSZ],upto[BFSZ],*c_str;
	int bkt,pile,spool,offset,len,n,newitem=0;
	int oldbkt,oldpile,oldspool,item,eof;
	String *s;
	FILE *bucketf=0,*feedf,*uptof;
	int nitems=0,total=0;

	*upto='\0';
again:	
	rename(feed_fname(filenames,".feed"),sendname);
	
	feedf=fopen(sendname,"rt");
	if(feedf==0) {
		imsg("Nothing to feed\n");
		xmit_done(FALSE);
		goto again;
	}

	if(!*upto) { /* Check upto file if necessary (after restart) */
		if(uptof=fopen(uptoname,"r")) {
			if(!fread(lbuff,BFSZ-1,1,uptof)) {
				if(c_str=strtok(lbuff," \t\r\n"))
					lprintf(upto,BFSZ-1,c_str);
			}
			else
				imsg("Could not read %s - ignoring\n",uptoname);
			fclose(uptof);
		}
		else 
			imsg("Could not open %s - must be starting a new feed file\n",uptoname);
	}
	else imsg("Continuing from - %s\n",upto);

	nitems=0;
newitem:
	oldspool=spool; oldpile=pile; oldbkt=bkt;	
	if(fget_next_info(feedf,mid,grp,&n,&bkt,&offset,&len,&pile,&spool,&eof)) {
		if(*upto && strcmp(upto,mid)!=0) goto newitem;
		*upto='\0';
		if(*mid) { 
			if(uptof=fopen(uptoname,"w+")) {
				fprintf(uptof,mid);
				fclose(uptof);
			}
		}
		if(bkt!=oldbkt || pile!=oldpile || spool!=oldspool || !bucketf) {
			lprintf(lbuff,BFSZ-1,"%s/db_%d_%d.itm",getSpoolDir(spool),bkt,pile);
			if(bucketf) fclose(bucketf);
			bucketf=fopen(lbuff,"r");
			if(bucketf==0) {
				emsg("Could not open %s, skipping item %s (%s:%d) - feed file mismatch?\n",lbuff,mid,grp,n);
				goto newitem;
			}
		}
	}
	else
	{	/* Assume we are at EOF */
		total+=nitems;
		imsg("Finished: %d processed (%d)\n",nitems,total);
		fclose(feedf);
		if(bucketf) fclose(bucketf);
		bucketf=feedf=0;		
		if(!eof && *mid) { 
			ncpy(upto,mid,BFSZ-1);
			if(uptof=fopen(uptoname,"w+")) {
				fprintf(uptof,mid);
				fclose(uptof);
			} else *upto='\0';
		}
		else { *upto='\0'; remove(uptoname); }
		xmit_done(eof);
		goto again;
	}

	if(fseek(bucketf,offset+=28,SEEK_SET)) {
		emsg("Could not seek to offset, skipping item %s (%s:%d) - feed file mismatch?\n",mid,grp,n);
		goto newitem;
	}	

	s=str_newsz(len+3);
	if(len=fread(str_s(s),1,len,bucketf)-28) fts_add(grp,n,*(s->s));
	if((++nitems)%50==0) imsg("%d processed\n",nitems);
	goto newitem;
}